"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = compose;
// https://github.com/reactjs/redux/blob/b4fb08133c95094a4b293a9ab434d1d5dd657527/src/compose.js
function compose() {
  for (var _len = arguments.length, funcs = Array(_len), _key = 0; _key < _len; _key++) {
    funcs[_key] = arguments[_key];
  }

  if (funcs.length === 0) {
    return function (arg) {
      return arg;
    };
  }

  if (funcs.length === 1) {
    return funcs[0];
  }

  return funcs.reduce(function (a, b) {
    return function () {
      return a(b.apply(undefined, arguments));
    };
  });
}