'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactRedux = require('react-redux');

var mapUIResponseToProps = function mapUIResponseToProps() {
  for (var _len = arguments.length, paths = Array(_len), _key = 0; _key < _len; _key++) {
    paths[_key] = arguments[_key];
  }

  return function (Target) {
    var Enhance = (0, _reactRedux.connect)(function (state) {
      return paths.reduce(function (props, path) {
        props[path + 'UI'] = state.ui[path];
        return props;
      }, {});
    })(Target);

    Enhance.originalContextTypes = Target.originalContextTypes || Target.contextTypes;
    Enhance.displayName = 'mapUIResponseToProps(' + Target.displayName + ')';
    return Enhance;
  };
};

exports.default = mapUIResponseToProps;